# -*- coding: utf-8 -*-
# <nbformat>3.0</nbformat>

from math import ceil
import requests
import time
import re
import csv

URL = "http://catalog.hathitrust.org/Search/Home"
Q = {'page':1, 'type':'callnoletters', 'lookfor':'QB', 'filter':'ht_availability:Full text', 'use_dismax':'1'}

def outputCSV(name):
    csvfile = open(name, 'wb+')
    IDwriter=csv.writer(csvfile, delimiter=',', quotechar='|', quoting=csv.QUOTE_MINIMAL)
    return IDwriter

def pageNumRegEx(requestobj):
    requestText = requestobj.text
    re1='(title)'   # Word 1
    re2='(=)'   # Any Single Character 1
    re3='("last page")' # Double Quote String 1
    re4='(>)'   # Any Single Character 2
    re5='(\\[)' # Any Single Character 3
    re6='(.*?)' # Integer Number 1
    re7='(\\])' # Any Single Character 4
    re8='(<\\/a>)'  # Tag 1
    rg = re.compile(re1+re2+re3+re4+re5+re6+re7+re8,re.IGNORECASE|re.DOTALL)
    m = rg.search(requestText)
    if m:
        word1=m.group(1)
        c1=m.group(2)
        string1=m.group(3)
        c2=m.group(4)
        c3=m.group(5)
        int1=m.group(6)
        c4=m.group(7)
        tag1=m.group(8)
        returnInt = int(int1)
    else:
        print "Error with regular expression. Number of Pages could not be found."
    return returnInt

def getNumPages(url):
    numPageGet = requests.get(url, params=Q)
    #r = re.search('title\=last page\>[\\d+]\<\/a\>', numPageGet.text)
    #r = re.search('of \<span class=\"strong\"\>(.*?)\<', numPageGet.text)
    pages = pageNumRegEx(numPageGet)
    print "Scraping "+str(pages)+" pages of results."
    return pages

#Gets record IDs which, when added to 'http://catalog.hathitrust.org/Record/' link to a main catalog entry, for which there may be several unique scans.
#It does this by picking the url parts out of each search result page.
def getRecordIDs(url, params):
    recordIDs = []
    pages = getNumPages(url)
    #pages = 5
    recordWriter=outputCSV('RecordIDs.csv')
    recordCounter = 0
    for n in range(1,pages+1):
        params['page']=n
        urlGet = requests.get(url, params=Q)
        m = re.findall('\<a href=\"\/Record\/(.*?)\?type', urlGet.text)
        for i in m:
            recordCounter+=1
            recordIDs.append(i)
            l = [i]
            recordWriter.writerow(l)
        print "Page "+str(n)+" finished. "+str(recordCounter)+" records retrieved so far."
    print "Retrieved "+str(recordCounter)+" record IDs."
    return recordIDs

#Gets the unique Hathi ID from each of pages referenced by the URL parts
def getHathiIDs(url, params):
    recordIDs = getRecordIDs(url, params)
    #HathiIDs=[]
    IDwriter=outputCSV('HathiIDs.csv')
    hathiCounter = 0
    recordCounter = 0
    for i in recordIDs:
        IDurl='http://catalog.hathitrust.org/Record/' + i
        urlGet=requests.get(IDurl)
        m=re.findall('\<a href=\"http\:\/\/hdl.handle.net\/2027\/(.*?)\"', urlGet.text)
        recordCounter+=1
        for i in m:
            #HathiIDs.append(i)
            l = [i]
            IDwriter.writerow(l)
            hathiCounter+=1
        time.sleep(1)
        if recordCounter%50==0:
            print str(recordCounter)+" records processed. "+str(hathiCounter)+" Hathi IDs retrieved."
    #return HathiIDs
    print "Retrieved "+str(hathiCounter)+" Hathi IDs."
    return 0

getHathiIDs(URL, Q)